#include <Arduino.h>

#include <SPI.h>
#include <ILI9341_due_config.h>
#include <ILI9341_due.h>
#include "fonts\Arial_bold_14.h"

#include <DueTimer.h>

//#include <URTouch.h>
#include <stdint.h>
#include <stdbool.h>


// Use hardware SPI (on Uno, #13, #12, #11) and the above for CS/DC
// For the Adafruit shield, these are the default.
#define LCD_LED_PIN 11
#define LED1_PIN 13
#define LED2_PIN 14
#define LED3_PIN 53
#define LED4_PIN 49
#define LED5_PIN 51
#define LED6_PIN 50

#define TFT_RST 8
#define TFT_DC 9
#define TFT_CS 10

struct Datum_s {
  int8_t Hour;
  int8_t Min;
  int8_t Sec;
  int8_t Day ;
  int8_t Month;
  int32_t Year;
} Datum;

 uint8_t Sec;

 char AlarmFunc[2][15] = {"Alarm Time 1","Alarm Time 2"};

 int clockCenterX=119;
 int clockCenterY=119;
 int oldsec;

// URTouch  myTouch(6, 5, 4, 3, 2);
ILI9341_due tft = ILI9341_due(TFT_CS, TFT_DC, TFT_RST);


 uint16_t ILI9341_WIDHT = 320;
 uint8_t ILI9341_HEIGTH = 240;

char strBuff[30];
/*************************
**   Custom functions   **
*************************/


/*************************
**  Required functions  **
*************************/


void setup()
{
	Serial.begin(9600);
	// Initial setup
	tft.begin();
	tft.setRotation(iliRotation270);	// landscape
	tft.fillScreen(ILI9341_BLACK);

//	myTouch.InitTouch();
	//myTouch.setPrecision(PREC_MEDIUM);

	tft.setFont(Arial_bold_14);

  pinMode(LCD_LED_PIN, OUTPUT);
  digitalWrite(LCD_LED_PIN, HIGH);

pinMode(LED1_PIN, OUTPUT);
Datum.Hour = 5;
Datum.Min = 3;
Datum.Sec = 0;
Datum.Day = 7;
Datum.Month = 9;
Datum.Year = 2016;

 pinMode(LED2_PIN, OUTPUT);
 pinMode(LED1_PIN, OUTPUT);
 pinMode(LED3_PIN, OUTPUT);
 pinMode(LED4_PIN, OUTPUT);
 pinMode(LED5_PIN, OUTPUT);
 pinMode(LED6_PIN, OUTPUT);
digitalWrite(LED4_PIN, HIGH);
digitalWrite(LED5_PIN, HIGH);
digitalWrite(LED6_PIN, HIGH);

Sec = 1;

Timer1.attachInterrupt(TMR1Handler);
Timer1.start(50000); // Calls every 50ms
Timer3.attachInterrupt(TMR3Handler);
Timer3.start(100000); // Calls every 500ms
Timer5.attachInterrupt(TMR5Handler);
Timer5.start(500000); // Calls every 500ms
drawDisplay();

}
     void TMR1Handler(void)
               {
         digitalWrite(LED2_PIN, digitalRead(LED2_PIN) ^ 1);
               }

  void TMR3Handler(void)
  {

// Test Routine um RTC zu simulieren

    if (Datum.Sec++ > 59) { // diese nerfige Routine benötigt man
      // weil sonst bei 12 Uhr Pixelreste unschön das Bild verunstalten
    tft.fillCircle(clockCenterX,clockCenterY,100,ILI9341_BLACK);
      drawMin(Datum.Min);
      drawHour(Datum.Hour,Datum.Min);
      Datum.Sec = 1;
    if (Datum.Min++ > 59)
     {
      Datum.Min = 0;


    if (Datum.Hour++ > 12 ){
       Datum.Hour = 1;
     }}}

  drawSec(Datum.Sec);
  PrintZeit(Datum.Hour, Datum.Min, Datum.Sec);
  }

  void TMR5Handler(void)
            {
      digitalWrite(LED4_PIN, digitalRead(LED4_PIN) ^ 1);
            }


void loop()
{
uint32_t x, y;

	while (true)
	{
/*		if (myTouch.dataAvailable())
		{
			myTouch.read();
			x = myTouch.getX();
			y = myTouch.getY();
}
*/
		}
	}
